Subject: Re: Bug: 'git config --local user.email=<alt.email>' fails silently?

From: Knut Omang <[email-masked]>
Date: Sun, 02 Apr 2017 09:53:39 +0200

On Sun, 2017-04-02 at 03:38 -0400, Jeff King wrote:
> On Sun, Apr 02, 2017 at 07:47:23AM +0200, Knut Omang wrote:
> 
> > From the documentation I would have expected 
> > 
> > git config --local user.email=[email-masked]
> > 
> > to create a section 
> > 
> > [user]
> > 	email=[email-masked]
> > 
> > in the local .git/config.
> 
> When it sees one argument, git-config treats that argument as a key to
> be retrieved. When given two, the second is a value to be set. E.g.:
> 
>   $ git config foo.bar
>   $ git config foo.bar some-value
>   $ git config foo.bar
>   some-value
> 
> So your command was interpreted as a request to fetch the value, which
> doesn't exist.
> 
> > Instead it returns status 1 with no error message.
> 
> Hopefully that explains the response you saw; we do not emit an error
> message when a key isn't found, which makes it easy for scripts to do
> things like:
> 
>   value=$(git config foo.bar || echo default-value)
> 
> without being unnecessarily noisy.
> 
> Usually we'd catch an error like yours and complain, because the key is
> syntactically invalid ("=" is not generally allowed in key names):
> 
>   $ git config foo.bar=some-value
>   error: invalid key: foo.bar=some-value
> 
> But your argument actually _is_ a syntactically valid key, because of
> the dots. In a three-level key like "one.two.three", the second level
> subsection is allowed to contain any character (including "=" and more
> dots). So your "user.email=[email-masked]" tries to look up the
> config represented by:
> 
>   [user "email=alt.email@alt"]
>   domain
> 
> Which of course did not exist.
> 
> > Is this intentional?
> 
> Yes, everything is working as intended. The documentation in
> git-config(1) seems to be quite poor at describing the various operating
> modes, though.

Ah - I see! 
Thanks for the quick answer and excellent explanation,
and sorry for the confusion - I should know well that config takes
the write argument after a blank.

I think I'll go and get myself another cup of coffee 
before I ask more questions anywhere...

Regards,
Knut

> -Peff